Codeforces Round #680 (Div. 2, based on Moscow Team Olympiad)-D. Divide and Sum

2024-01-11 05:32

本文主要是介绍Codeforces Round #680 (Div. 2, based on Moscow Team Olympiad)-D. Divide and Sum,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接

You are given an array a of length 2n. Consider a partition of array a into two subsequences p and q of length n each (each element of array a should be in exactly one subsequence: either in p or in q).

Let’s sort p in non-decreasing order, and q in non-increasing order, we can denote the sorted versions by x and y, respectively. Then the cost of a partition is defined as f(p,q)=∑ni=1|xi−yi|.

Find the sum of f(p,q) over all correct partitions of array a. Since the answer might be too big, print its remainder modulo 998244353.

Input
The first line contains a single integer n (1≤n≤150000).

The second line contains 2n integers a1,a2,…,a2n (1≤ai≤109) — elements of array a.

Output
Print one integer — the answer to the problem, modulo 998244353.

Examples
input
1
1 4
output
6
input
2
2 1 2 1
output
12
input
3
2 2 2 2 2 2
output
0
input
5
13 8 35 94 9284 34 54 69 123 846
output
2588544
Note
Two partitions of an array are considered different if the sets of indices of elements included in the subsequence p are different.

In the first example, there are two correct partitions of the array a:

p=[1], q=[4], then x=[1], y=[4], f(p,q)=|1−4|=3;
p=[4], q=[1], then x=[4], y=[1], f(p,q)=|4−1|=3.
In the second example, there are six valid partitions of the array a:

p=[2,1], q=[2,1] (elements with indices 1 and 2 in the original array are selected in the subsequence p);
p=[2,2], q=[1,1];
p=[2,1], q=[1,2] (elements with indices 1 and 4 are selected in the subsequence p);
p=[1,2], q=[2,1];
p=[1,1], q=[2,2];
p=[2,1], q=[2,1] (elements with indices 3 and 4 are selected in the subsequence p).

题意:给定一个长度为2*n的数组a,将a分成两份放在p数组和q数组里,p和q的长度相同,且里面的元素都来自a数组并且在a数组里一一对应,p非降序排列成数组x,q非升序排列为y,
我们设 f ( p , q ) = ∑ i = 1 n ∣ x i − y i ∣ f(p,q)=\sum_{i=1}^n|x_i-y_i| f(p,q)=i=1nxiyi,求所有不重复排列的 f ( p , q ) f(p,q) f(p,q)的和,结果模998244353取余

思路:这题完全就是一个排序求和然后求排列组合就行了,我们可以先将a数组排序,然后去分成两个数组,假设 n = 2 n=2 n=2,同时 a 1 , a 2 , a 3 , a 3 a_1,a_2,a_3,a_3 a1,a2,a3,a3升序排列,则所有 f ( p , q ) f(p,q) f(p,q)的和可以计算出结果为 C 2 ∗ n n ∗ ( a 4 + a 3 − a 2 − a 1 ) C_{2*n}^n*(a_4+a_3-a_2-a_1) C2nn(a4+a3a2a1),算到这里就已经差不多了,排序求前半段和后半段的和然后做差,再求排列组合,相乘即可,我再做差这个地方错了两次,因为前面取模可能导致总和小于数组一半的和,所以在这个地方最好是先加上MOD,再做差,然后再取模

#include<bits/stdc++.h>
#define ll long long
using namespace std;
const ll MOD=998244353;
const ll N=2e5+5;
const ll INF=0x3f3f3f;
ll V[N];
void init()
{V[1]=1;for(int i=2;i<N;i++)V[i]=V[i-1]*2%MOD;
}
ll mod_pow(ll x, ll n, ll p){ll res = 1;while(n){if(n & 1) res =res * x % p;x = x * x % p;n >>= 1;}return res;
}ll comb(ll n, ll m, ll p){if(m > n) return 0;ll ret = 1;m = min(n - m, m);for(int i = 1; i <= m; i ++){ll a = (n + i - m) % p;ll b = i % p;ret = ret * (a * mod_pow(b, p - 2, p) % p) % p;}return ret;
}ll Lucas(ll n, ll m, ll p){//从n中选m个取模;if(m == 0) return 1;return comb(n % p, m % p, p) * Lucas(n / p, m / p, p) % p;
}ll Mpow(ll a,ll b){ll r=1,base=a;while(b){if(b&1) r*=base;base*=base;b>>=1;}return r;
}void slove()
{ll n;cin>>n;n*=2;ll a[n+5];ll sum=0;for(ll i=0;i<n;i++){cin>>a[i];sum+=a[i];sum%=MOD;}sort(a,a+n);ll sum1=0;for(ll i=0;i<n/2;i++){sum1+=a[i];sum1%=MOD;}sum=sum+MOD-sum1;sum%=MOD;sum=sum+MOD-sum1;sum%=MOD;ll ans=((Lucas(n,n/2,MOD)%MOD)*sum)%MOD;cout<<ans%MOD<<endl;
}
int main()
{ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);//init();//int t;cin>>t;//while(t--)slove();return 0;
}

这篇关于Codeforces Round #680 (Div. 2, based on Moscow Team Olympiad)-D. Divide and Sum的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/593314

相关文章

Retrieval-based-Voice-Conversion-WebUI模型构建指南

一、模型介绍 Retrieval-based-Voice-Conversion-WebUI(简称 RVC)模型是一个基于 VITS(Variational Inference with adversarial learning for end-to-end Text-to-Speech)的简单易用的语音转换框架。 具有以下特点 简单易用:RVC 模型通过简单易用的网页界面,使得用户无需深入了

最大流=最小割=最小点权覆盖集=sum-最大点权独立集

二分图最小点覆盖和最大独立集都可以转化为最大匹配求解。 在这个基础上,把每个点赋予一个非负的权值,这两个问题就转化为:二分图最小点权覆盖和二分图最大点权独立集。   二分图最小点权覆盖     从x或者y集合中选取一些点,使这些点覆盖所有的边,并且选出来的点的权值尽可能小。 建模:     原二分图中的边(u,v)替换为容量为INF的有向边(u,v),设立源点s和汇点t

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

如何导入sun.misc.BASE64Encoder和sum.misc.BASE64Decoder

右击项目名--->Build Path--->Configure Build Path...--->java Build Path--->Access rules:1 rule defined,added to all librar...   --->Edit --->Add...

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;